scala.reflect.api.Trees

# Traverser

#### class Traverser extends AnyRef

A class that implement a default tree traversal strategy: breadth-first component-wise.

Source
  Trees.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Traverser
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Traverser()

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Universe.Traverser to any2stringadd[Universe.Traverser] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Universe.Traverser, B)

   Implicit information
     This member is added by an implicit conversion from Universe.Traverser to ArrowAssoc[Universe.Traverser] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def apply[T <: Universe.Tree](tree: T): T

   Leave apply available in the generic traverser to do something else.

7. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

8. #### def atOwner(owner: Universe.Symbol)(traverse: ⇒ Unit): Unit

   Performs a traversal with a given owner symbol.

9. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

10. #### var currentOwner: Universe.Symbol

    Attributes
      protected[scala]

11. #### def ensuring(cond: (Universe.Traverser) ⇒ Boolean, msg: ⇒ Any): Universe.Traverser

    Implicit information
      This member is added by an implicit conversion from Universe.Traverser to Ensuring[Universe.Traverser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (Universe.Traverser) ⇒ Boolean): Universe.Traverser

    Implicit information
      This member is added by an implicit conversion from Universe.Traverser to Ensuring[Universe.Traverser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): Universe.Traverser

    Implicit information
      This member is added by an implicit conversion from Universe.Traverser to Ensuring[Universe.Traverser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): Universe.Traverser

    Implicit information
      This member is added by an implicit conversion from Universe.Traverser to Ensuring[Universe.Traverser] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Universe.Traverser to StringFormat[Universe.Traverser] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

20. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

21. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

22. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

23. #### final def notify(): Unit

    Definition Classes
      AnyRef

24. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

25. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

26. #### def toString(): String

    Definition Classes
      AnyRef → Any

27. #### def traverse(tree: Universe.Tree): Unit

    Traverses a single tree.

28. #### def traverseAnnotations(annots: List[Universe.Tree]): Unit

29. #### def traverseCases(cases: List[Universe.CaseDef]): Unit

30. #### def traverseConstant(c: Universe.Constant): Unit

31. #### def traverseGuard(guard: Universe.Tree): Unit

32. #### def traverseImportSelector(sel: Universe.ImportSelector): Unit

33. #### def traverseModifiers(mods: Universe.Modifiers): Unit

34. #### def traverseName(name: Universe.Name): Unit

    Traverse something which Trees contain, but which isn't a Tree itself.

35. #### def traverseParams(params: List[Universe.Tree]): Unit

36. #### def traverseParamss(vparamss: List[List[Universe.Tree]]): Unit

37. #### def traverseParents(parents: List[Universe.Tree]): Unit

38. #### def traversePattern(pat: Universe.Tree): Unit

39. #### def traverseSelfType(self: Universe.ValDef): Unit

40. #### def traverseStats(stats: List[Universe.Tree], exprOwner: Universe.Symbol): Unit

    Traverses a list of trees with a given owner symbol.

41. #### def traverseTrees(trees: List[Universe.Tree]): Unit

    Traverses a list of trees.

42. #### def traverseTreess(treess: List[List[Universe.Tree]]): Unit

    Traverses a list of lists of trees.

43. #### def traverseTypeArgs(args: List[Universe.Tree]): Unit

44. #### def traverseTypeAscription(tpt: Universe.Tree): Unit

45. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

47. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### def →[B](y: B): (Universe.Traverser, B)

    Implicit information
      This member is added by an implicit conversion from Universe.Traverser to ArrowAssoc[Universe.Traverser] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Universe.Traverser to any2stringadd[Universe.Traverser]

### Inherited by implicit conversion StringFormat from Universe.Traverser to StringFormat[Universe.Traverser]

### Inherited by implicit conversion Ensuring from Universe.Traverser to Ensuring[Universe.Traverser]

### Inherited by implicit conversion ArrowAssoc from Universe.Traverser to ArrowAssoc[Universe.Traverser]

### Ungrouped